"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from orq_ai_sdk import utils
from orq_ai_sdk.types import BaseModel, Nullable, UNSET_SENTINEL
from pydantic import model_serializer
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class EvalsRagasContextRecallRequestBodyTypedDict(TypedDict):
    model: str
    reference: str
    r"""The ground truth answer to evaluate context recall against"""
    query: NotRequired[str]
    r"""Latest user message"""
    output: NotRequired[str]
    r"""The generated response from the model"""
    retrievals: NotRequired[List[str]]
    r"""Knowledge base retrievals"""


class EvalsRagasContextRecallRequestBody(BaseModel):
    model: str

    reference: str
    r"""The ground truth answer to evaluate context recall against"""

    query: Optional[str] = None
    r"""Latest user message"""

    output: Optional[str] = None
    r"""The generated response from the model"""

    retrievals: Optional[List[str]] = None
    r"""Knowledge base retrievals"""


class EvalsRagasContextRecallEvalsResponseResponseBodyData(BaseModel):
    message: str


class EvalsRagasContextRecallEvalsResponseResponseBody(Exception):
    r"""Internal server error"""

    data: EvalsRagasContextRecallEvalsResponseResponseBodyData

    def __init__(self, data: EvalsRagasContextRecallEvalsResponseResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, EvalsRagasContextRecallEvalsResponseResponseBodyData
        )


class EvalsRagasContextRecallEvalsResponseBodyData(BaseModel):
    message: str


class EvalsRagasContextRecallEvalsResponseBody(Exception):
    r"""Evaluator not found"""

    data: EvalsRagasContextRecallEvalsResponseBodyData

    def __init__(self, data: EvalsRagasContextRecallEvalsResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, EvalsRagasContextRecallEvalsResponseBodyData
        )


class EvalsRagasContextRecallResponseBodyTypedDict(TypedDict):
    r"""Returns the context recall evaluation result"""

    value: Nullable[float]


class EvalsRagasContextRecallResponseBody(BaseModel):
    r"""Returns the context recall evaluation result"""

    value: Nullable[float]

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["value"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
