"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from orq_ai_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from orq_ai_sdk.utils import (
    FieldMetadata,
    PathParamMetadata,
    RequestMetadata,
    parse_datetime,
)
import pydantic
from pydantic import model_serializer
from typing import Any, Dict, List, Literal, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


UpdateDatapointMessagesDatasetsRequestRequestBody5Role = Literal["tool"]
r"""The role of the messages author, in this case tool."""

UpdateDatapointMessagesDatasetsRequestContentTypedDict = TypeAliasType(
    "UpdateDatapointMessagesDatasetsRequestContentTypedDict", Union[str, List[str]]
)
r"""The contents of the tool message."""


UpdateDatapointMessagesDatasetsRequestContent = TypeAliasType(
    "UpdateDatapointMessagesDatasetsRequestContent", Union[str, List[str]]
)
r"""The contents of the tool message."""


class UpdateDatapointMessagesToolMessageTypedDict(TypedDict):
    role: UpdateDatapointMessagesDatasetsRequestRequestBody5Role
    r"""The role of the messages author, in this case tool."""
    content: UpdateDatapointMessagesDatasetsRequestContentTypedDict
    r"""The contents of the tool message."""
    tool_call_id: str
    r"""Tool call that this message is responding to."""


class UpdateDatapointMessagesToolMessage(BaseModel):
    role: UpdateDatapointMessagesDatasetsRequestRequestBody5Role
    r"""The role of the messages author, in this case tool."""

    content: UpdateDatapointMessagesDatasetsRequestContent
    r"""The contents of the tool message."""

    tool_call_id: str
    r"""Tool call that this message is responding to."""


UpdateDatapoint2DatasetsRequestRequestBodyMessages4Type = Literal["refusal"]
r"""The type of the content part."""


class UpdateDatapoint2RefusalContentPartTypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsRequestRequestBodyMessages4Type
    r"""The type of the content part."""
    refusal: str
    r"""The refusal message generated by the model."""


class UpdateDatapoint2RefusalContentPart(BaseModel):
    type: UpdateDatapoint2DatasetsRequestRequestBodyMessages4Type
    r"""The type of the content part."""

    refusal: str
    r"""The refusal message generated by the model."""


UpdateDatapoint2DatasetsRequestRequestBodyMessagesType = Literal["text"]
r"""The type of the content part."""


class UpdateDatapoint2TextContentPartTypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsRequestRequestBodyMessagesType
    r"""The type of the content part."""
    text: str
    r"""The text content."""


class UpdateDatapoint2TextContentPart(BaseModel):
    type: UpdateDatapoint2DatasetsRequestRequestBodyMessagesType
    r"""The type of the content part."""

    text: str
    r"""The text content."""


UpdateDatapointContentDatasets2TypedDict = TypeAliasType(
    "UpdateDatapointContentDatasets2TypedDict",
    Union[
        UpdateDatapoint2TextContentPartTypedDict,
        UpdateDatapoint2RefusalContentPartTypedDict,
    ],
)


UpdateDatapointContentDatasets2 = TypeAliasType(
    "UpdateDatapointContentDatasets2",
    Union[UpdateDatapoint2TextContentPart, UpdateDatapoint2RefusalContentPart],
)


UpdateDatapointMessagesDatasetsContentTypedDict = TypeAliasType(
    "UpdateDatapointMessagesDatasetsContentTypedDict",
    Union[str, List[UpdateDatapointContentDatasets2TypedDict]],
)
r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""


UpdateDatapointMessagesDatasetsContent = TypeAliasType(
    "UpdateDatapointMessagesDatasetsContent",
    Union[str, List[UpdateDatapointContentDatasets2]],
)
r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""


UpdateDatapointMessagesDatasetsRequestRequestBodyRole = Literal["assistant"]
r"""The role of the messages author, in this case `assistant`."""


class UpdateDatapointMessagesAudioTypedDict(TypedDict):
    r"""Data about a previous audio response from the model."""

    id: str
    r"""Unique identifier for a previous audio response from the model."""


class UpdateDatapointMessagesAudio(BaseModel):
    r"""Data about a previous audio response from the model."""

    id: str
    r"""Unique identifier for a previous audio response from the model."""


UpdateDatapointMessagesType = Literal["function"]
r"""The type of the tool. Currently, only `function` is supported."""


class UpdateDatapointMessagesFunctionTypedDict(TypedDict):
    name: NotRequired[str]
    r"""The name of the function to call."""
    arguments: NotRequired[str]
    r"""The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function."""


class UpdateDatapointMessagesFunction(BaseModel):
    name: Optional[str] = None
    r"""The name of the function to call."""

    arguments: Optional[str] = None
    r"""The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function."""


class UpdateDatapointMessagesToolCallsTypedDict(TypedDict):
    id: str
    r"""The ID of the tool call."""
    type: UpdateDatapointMessagesType
    r"""The type of the tool. Currently, only `function` is supported."""
    function: UpdateDatapointMessagesFunctionTypedDict


class UpdateDatapointMessagesToolCalls(BaseModel):
    id: str
    r"""The ID of the tool call."""

    type: UpdateDatapointMessagesType
    r"""The type of the tool. Currently, only `function` is supported."""

    function: UpdateDatapointMessagesFunction


class UpdateDatapointMessagesAssistantMessageTypedDict(TypedDict):
    role: UpdateDatapointMessagesDatasetsRequestRequestBodyRole
    r"""The role of the messages author, in this case `assistant`."""
    content: NotRequired[Nullable[UpdateDatapointMessagesDatasetsContentTypedDict]]
    r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""
    refusal: NotRequired[Nullable[str]]
    r"""The refusal message by the assistant."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""
    audio: NotRequired[Nullable[UpdateDatapointMessagesAudioTypedDict]]
    r"""Data about a previous audio response from the model."""
    tool_calls: NotRequired[List[UpdateDatapointMessagesToolCallsTypedDict]]
    r"""The tool calls generated by the model, such as function calls."""
    reasoning: NotRequired[str]
    r"""Internal thought process of the model"""
    reasoning_signature: NotRequired[str]
    r"""The signature holds a cryptographic token which verifies that the thinking block was generated by the model, and is verified when thinking is part of a multiturn conversation. This value should not be modified and should always be sent to the API when the reasoning is redacted. Currently only supported by `Anthropic`."""
    redacted_reasoning: NotRequired[str]
    r"""Occasionally the model's internal reasoning will be flagged by the safety systems of the provider. When this occurs, the provider will encrypt the reasoning. These redacted reasoning is decrypted when passed back to the API, allowing the model to continue its response without losing context."""


class UpdateDatapointMessagesAssistantMessage(BaseModel):
    role: UpdateDatapointMessagesDatasetsRequestRequestBodyRole
    r"""The role of the messages author, in this case `assistant`."""

    content: OptionalNullable[UpdateDatapointMessagesDatasetsContent] = UNSET
    r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""

    refusal: OptionalNullable[str] = UNSET
    r"""The refusal message by the assistant."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""

    audio: OptionalNullable[UpdateDatapointMessagesAudio] = UNSET
    r"""Data about a previous audio response from the model."""

    tool_calls: Optional[List[UpdateDatapointMessagesToolCalls]] = None
    r"""The tool calls generated by the model, such as function calls."""

    reasoning: Optional[str] = None
    r"""Internal thought process of the model"""

    reasoning_signature: Optional[str] = None
    r"""The signature holds a cryptographic token which verifies that the thinking block was generated by the model, and is verified when thinking is part of a multiturn conversation. This value should not be modified and should always be sent to the API when the reasoning is redacted. Currently only supported by `Anthropic`."""

    redacted_reasoning: Optional[str] = None
    r"""Occasionally the model's internal reasoning will be flagged by the safety systems of the provider. When this occurs, the provider will encrypt the reasoning. These redacted reasoning is decrypted when passed back to the API, allowing the model to continue its response without losing context."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "content",
            "refusal",
            "name",
            "audio",
            "tool_calls",
            "reasoning",
            "reasoning_signature",
            "redacted_reasoning",
        ]
        nullable_fields = ["content", "refusal", "audio"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


UpdateDatapointMessagesDatasetsRequestRole = Literal["user"]
r"""The role of the messages author, in this case `user`."""

UpdateDatapoint2DatasetsRequestRequestBodyType = Literal["file"]
r"""The type of the content part. Always `file`."""


class UpdateDatapoint2FileTypedDict(TypedDict):
    file_data: str
    r"""The base64 encoded file data, used when passing the file to the model as a string."""
    filename: str
    r"""The name of the file, used when passing the file to the model as a string."""


class UpdateDatapoint2File(BaseModel):
    file_data: str
    r"""The base64 encoded file data, used when passing the file to the model as a string."""

    filename: str
    r"""The name of the file, used when passing the file to the model as a string."""


class UpdateDatapoint24TypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsRequestRequestBodyType
    r"""The type of the content part. Always `file`."""
    file: UpdateDatapoint2FileTypedDict


class UpdateDatapoint24(BaseModel):
    type: UpdateDatapoint2DatasetsRequestRequestBodyType
    r"""The type of the content part. Always `file`."""

    file: UpdateDatapoint2File


UpdateDatapoint2DatasetsRequestType = Literal["input_audio"]

UpdateDatapoint2Format = Literal["mp3", "wav"]
r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class UpdateDatapoint2InputAudioTypedDict(TypedDict):
    data: str
    r"""Base64 encoded audio data."""
    format_: UpdateDatapoint2Format
    r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class UpdateDatapoint2InputAudio(BaseModel):
    data: str
    r"""Base64 encoded audio data."""

    format_: Annotated[UpdateDatapoint2Format, pydantic.Field(alias="format")]
    r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class UpdateDatapoint23TypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsRequestType
    input_audio: UpdateDatapoint2InputAudioTypedDict


class UpdateDatapoint23(BaseModel):
    type: UpdateDatapoint2DatasetsRequestType

    input_audio: UpdateDatapoint2InputAudio


UpdateDatapoint2DatasetsType = Literal["image_url"]

UpdateDatapoint2Detail = Literal["low", "high", "auto"]
r"""Specifies the detail level of the image."""


class UpdateDatapoint2ImageURLTypedDict(TypedDict):
    url: str
    r"""Either a URL of the image or the base64 encoded image data."""
    detail: NotRequired[UpdateDatapoint2Detail]
    r"""Specifies the detail level of the image."""


class UpdateDatapoint2ImageURL(BaseModel):
    url: str
    r"""Either a URL of the image or the base64 encoded image data."""

    detail: Optional[UpdateDatapoint2Detail] = None
    r"""Specifies the detail level of the image."""


class UpdateDatapoint22TypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsType
    image_url: UpdateDatapoint2ImageURLTypedDict


class UpdateDatapoint22(BaseModel):
    type: UpdateDatapoint2DatasetsType

    image_url: UpdateDatapoint2ImageURL


UpdateDatapoint2Type = Literal["text"]


class UpdateDatapoint21TypedDict(TypedDict):
    type: UpdateDatapoint2Type
    text: str


class UpdateDatapoint21(BaseModel):
    type: UpdateDatapoint2Type

    text: str


UpdateDatapointContent2TypedDict = TypeAliasType(
    "UpdateDatapointContent2TypedDict",
    Union[
        UpdateDatapoint21TypedDict,
        UpdateDatapoint22TypedDict,
        UpdateDatapoint23TypedDict,
        UpdateDatapoint24TypedDict,
    ],
)


UpdateDatapointContent2 = TypeAliasType(
    "UpdateDatapointContent2",
    Union[UpdateDatapoint21, UpdateDatapoint22, UpdateDatapoint23, UpdateDatapoint24],
)


UpdateDatapointMessagesContentTypedDict = TypeAliasType(
    "UpdateDatapointMessagesContentTypedDict",
    Union[str, List[UpdateDatapointContent2TypedDict]],
)
r"""The contents of the user message."""


UpdateDatapointMessagesContent = TypeAliasType(
    "UpdateDatapointMessagesContent", Union[str, List[UpdateDatapointContent2]]
)
r"""The contents of the user message."""


class UpdateDatapointMessagesUserMessageTypedDict(TypedDict):
    role: UpdateDatapointMessagesDatasetsRequestRole
    r"""The role of the messages author, in this case `user`."""
    content: UpdateDatapointMessagesContentTypedDict
    r"""The contents of the user message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class UpdateDatapointMessagesUserMessage(BaseModel):
    role: UpdateDatapointMessagesDatasetsRequestRole
    r"""The role of the messages author, in this case `user`."""

    content: UpdateDatapointMessagesContent
    r"""The contents of the user message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


UpdateDatapointMessagesDatasetsRole = Literal["system"]
r"""The role of the messages author, in this case `system`."""


class UpdateDatapointMessagesSystemMessageTypedDict(TypedDict):
    role: UpdateDatapointMessagesDatasetsRole
    r"""The role of the messages author, in this case `system`."""
    content: str
    r"""The contents of the system message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class UpdateDatapointMessagesSystemMessage(BaseModel):
    role: UpdateDatapointMessagesDatasetsRole
    r"""The role of the messages author, in this case `system`."""

    content: str
    r"""The contents of the system message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


UpdateDatapointMessagesRole = Literal["developer"]
r"""The role of the messages author, in this case  `developer`."""


class UpdateDatapointMessagesDeveloperMessageTypedDict(TypedDict):
    role: UpdateDatapointMessagesRole
    r"""The role of the messages author, in this case  `developer`."""
    content: str
    r"""The contents of the developer message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class UpdateDatapointMessagesDeveloperMessage(BaseModel):
    role: UpdateDatapointMessagesRole
    r"""The role of the messages author, in this case  `developer`."""

    content: str
    r"""The contents of the developer message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


UpdateDatapointMessagesTypedDict = TypeAliasType(
    "UpdateDatapointMessagesTypedDict",
    Union[
        UpdateDatapointMessagesDeveloperMessageTypedDict,
        UpdateDatapointMessagesSystemMessageTypedDict,
        UpdateDatapointMessagesUserMessageTypedDict,
        UpdateDatapointMessagesToolMessageTypedDict,
        UpdateDatapointMessagesAssistantMessageTypedDict,
    ],
)


UpdateDatapointMessages = TypeAliasType(
    "UpdateDatapointMessages",
    Union[
        UpdateDatapointMessagesDeveloperMessage,
        UpdateDatapointMessagesSystemMessage,
        UpdateDatapointMessagesUserMessage,
        UpdateDatapointMessagesToolMessage,
        UpdateDatapointMessagesAssistantMessage,
    ],
)


class UpdateDatapointRequestBodyTypedDict(TypedDict):
    inputs: NotRequired[Dict[str, Any]]
    r"""The inputs of the dataset. Key value pairs where the key is the input name and the value is the input value. Nested objects are not supported."""
    messages: NotRequired[List[UpdateDatapointMessagesTypedDict]]
    r"""A list of messages comprising the conversation so far"""
    expected_output: NotRequired[str]


class UpdateDatapointRequestBody(BaseModel):
    inputs: Optional[Dict[str, Any]] = None
    r"""The inputs of the dataset. Key value pairs where the key is the input name and the value is the input value. Nested objects are not supported."""

    messages: Optional[List[UpdateDatapointMessages]] = None
    r"""A list of messages comprising the conversation so far"""

    expected_output: Optional[str] = None


class UpdateDatapointRequestTypedDict(TypedDict):
    dataset_id: str
    datapoint_id: str
    request_body: NotRequired[UpdateDatapointRequestBodyTypedDict]


class UpdateDatapointRequest(BaseModel):
    dataset_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]

    datapoint_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]

    request_body: Annotated[
        Optional[UpdateDatapointRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None


UpdateDatapointMessagesDatasetsResponse200ApplicationJSONResponseBody5Role = Literal[
    "tool"
]
r"""The role of the messages author, in this case tool."""

UpdateDatapointMessagesDatasetsResponse200ApplicationJSONContentTypedDict = (
    TypeAliasType(
        "UpdateDatapointMessagesDatasetsResponse200ApplicationJSONContentTypedDict",
        Union[str, List[str]],
    )
)
r"""The contents of the tool message."""


UpdateDatapointMessagesDatasetsResponse200ApplicationJSONContent = TypeAliasType(
    "UpdateDatapointMessagesDatasetsResponse200ApplicationJSONContent",
    Union[str, List[str]],
)
r"""The contents of the tool message."""


class UpdateDatapointMessagesDatasetsToolMessageTypedDict(TypedDict):
    role: UpdateDatapointMessagesDatasetsResponse200ApplicationJSONResponseBody5Role
    r"""The role of the messages author, in this case tool."""
    content: UpdateDatapointMessagesDatasetsResponse200ApplicationJSONContentTypedDict
    r"""The contents of the tool message."""
    tool_call_id: str
    r"""Tool call that this message is responding to."""


class UpdateDatapointMessagesDatasetsToolMessage(BaseModel):
    role: UpdateDatapointMessagesDatasetsResponse200ApplicationJSONResponseBody5Role
    r"""The role of the messages author, in this case tool."""

    content: UpdateDatapointMessagesDatasetsResponse200ApplicationJSONContent
    r"""The contents of the tool message."""

    tool_call_id: str
    r"""Tool call that this message is responding to."""


UpdateDatapoint2DatasetsResponse200ApplicationJSONResponseBodyMessages4Type = Literal[
    "refusal"
]
r"""The type of the content part."""


class UpdateDatapoint2DatasetsRefusalContentPartTypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsResponse200ApplicationJSONResponseBodyMessages4Type
    r"""The type of the content part."""
    refusal: str
    r"""The refusal message generated by the model."""


class UpdateDatapoint2DatasetsRefusalContentPart(BaseModel):
    type: UpdateDatapoint2DatasetsResponse200ApplicationJSONResponseBodyMessages4Type
    r"""The type of the content part."""

    refusal: str
    r"""The refusal message generated by the model."""


UpdateDatapoint2DatasetsResponse200ApplicationJSONResponseBodyMessagesType = Literal[
    "text"
]
r"""The type of the content part."""


class UpdateDatapoint2DatasetsTextContentPartTypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsResponse200ApplicationJSONResponseBodyMessagesType
    r"""The type of the content part."""
    text: str
    r"""The text content."""


class UpdateDatapoint2DatasetsTextContentPart(BaseModel):
    type: UpdateDatapoint2DatasetsResponse200ApplicationJSONResponseBodyMessagesType
    r"""The type of the content part."""

    text: str
    r"""The text content."""


UpdateDatapointContentDatasetsResponse2002TypedDict = TypeAliasType(
    "UpdateDatapointContentDatasetsResponse2002TypedDict",
    Union[
        UpdateDatapoint2DatasetsTextContentPartTypedDict,
        UpdateDatapoint2DatasetsRefusalContentPartTypedDict,
    ],
)


UpdateDatapointContentDatasetsResponse2002 = TypeAliasType(
    "UpdateDatapointContentDatasetsResponse2002",
    Union[
        UpdateDatapoint2DatasetsTextContentPart,
        UpdateDatapoint2DatasetsRefusalContentPart,
    ],
)


UpdateDatapointMessagesDatasetsResponse200ContentTypedDict = TypeAliasType(
    "UpdateDatapointMessagesDatasetsResponse200ContentTypedDict",
    Union[str, List[UpdateDatapointContentDatasetsResponse2002TypedDict]],
)
r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""


UpdateDatapointMessagesDatasetsResponse200Content = TypeAliasType(
    "UpdateDatapointMessagesDatasetsResponse200Content",
    Union[str, List[UpdateDatapointContentDatasetsResponse2002]],
)
r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""


UpdateDatapointMessagesDatasetsResponse200ApplicationJSONResponseBodyRole = Literal[
    "assistant"
]
r"""The role of the messages author, in this case `assistant`."""


class UpdateDatapointMessagesDatasetsAudioTypedDict(TypedDict):
    r"""Data about a previous audio response from the model."""

    id: str
    r"""Unique identifier for a previous audio response from the model."""


class UpdateDatapointMessagesDatasetsAudio(BaseModel):
    r"""Data about a previous audio response from the model."""

    id: str
    r"""Unique identifier for a previous audio response from the model."""


UpdateDatapointMessagesDatasetsType = Literal["function"]
r"""The type of the tool. Currently, only `function` is supported."""


class UpdateDatapointMessagesDatasetsFunctionTypedDict(TypedDict):
    name: NotRequired[str]
    r"""The name of the function to call."""
    arguments: NotRequired[str]
    r"""The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function."""


class UpdateDatapointMessagesDatasetsFunction(BaseModel):
    name: Optional[str] = None
    r"""The name of the function to call."""

    arguments: Optional[str] = None
    r"""The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function."""


class UpdateDatapointMessagesDatasetsToolCallsTypedDict(TypedDict):
    id: str
    r"""The ID of the tool call."""
    type: UpdateDatapointMessagesDatasetsType
    r"""The type of the tool. Currently, only `function` is supported."""
    function: UpdateDatapointMessagesDatasetsFunctionTypedDict


class UpdateDatapointMessagesDatasetsToolCalls(BaseModel):
    id: str
    r"""The ID of the tool call."""

    type: UpdateDatapointMessagesDatasetsType
    r"""The type of the tool. Currently, only `function` is supported."""

    function: UpdateDatapointMessagesDatasetsFunction


class UpdateDatapointMessagesDatasetsAssistantMessageTypedDict(TypedDict):
    role: UpdateDatapointMessagesDatasetsResponse200ApplicationJSONResponseBodyRole
    r"""The role of the messages author, in this case `assistant`."""
    content: NotRequired[
        Nullable[UpdateDatapointMessagesDatasetsResponse200ContentTypedDict]
    ]
    r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""
    refusal: NotRequired[Nullable[str]]
    r"""The refusal message by the assistant."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""
    audio: NotRequired[Nullable[UpdateDatapointMessagesDatasetsAudioTypedDict]]
    r"""Data about a previous audio response from the model."""
    tool_calls: NotRequired[List[UpdateDatapointMessagesDatasetsToolCallsTypedDict]]
    r"""The tool calls generated by the model, such as function calls."""
    reasoning: NotRequired[str]
    r"""Internal thought process of the model"""
    reasoning_signature: NotRequired[str]
    r"""The signature holds a cryptographic token which verifies that the thinking block was generated by the model, and is verified when thinking is part of a multiturn conversation. This value should not be modified and should always be sent to the API when the reasoning is redacted. Currently only supported by `Anthropic`."""
    redacted_reasoning: NotRequired[str]
    r"""Occasionally the model's internal reasoning will be flagged by the safety systems of the provider. When this occurs, the provider will encrypt the reasoning. These redacted reasoning is decrypted when passed back to the API, allowing the model to continue its response without losing context."""


class UpdateDatapointMessagesDatasetsAssistantMessage(BaseModel):
    role: UpdateDatapointMessagesDatasetsResponse200ApplicationJSONResponseBodyRole
    r"""The role of the messages author, in this case `assistant`."""

    content: OptionalNullable[UpdateDatapointMessagesDatasetsResponse200Content] = UNSET
    r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""

    refusal: OptionalNullable[str] = UNSET
    r"""The refusal message by the assistant."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""

    audio: OptionalNullable[UpdateDatapointMessagesDatasetsAudio] = UNSET
    r"""Data about a previous audio response from the model."""

    tool_calls: Optional[List[UpdateDatapointMessagesDatasetsToolCalls]] = None
    r"""The tool calls generated by the model, such as function calls."""

    reasoning: Optional[str] = None
    r"""Internal thought process of the model"""

    reasoning_signature: Optional[str] = None
    r"""The signature holds a cryptographic token which verifies that the thinking block was generated by the model, and is verified when thinking is part of a multiturn conversation. This value should not be modified and should always be sent to the API when the reasoning is redacted. Currently only supported by `Anthropic`."""

    redacted_reasoning: Optional[str] = None
    r"""Occasionally the model's internal reasoning will be flagged by the safety systems of the provider. When this occurs, the provider will encrypt the reasoning. These redacted reasoning is decrypted when passed back to the API, allowing the model to continue its response without losing context."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "content",
            "refusal",
            "name",
            "audio",
            "tool_calls",
            "reasoning",
            "reasoning_signature",
            "redacted_reasoning",
        ]
        nullable_fields = ["content", "refusal", "audio"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


UpdateDatapointMessagesDatasetsResponse200ApplicationJSONRole = Literal["user"]
r"""The role of the messages author, in this case `user`."""

UpdateDatapoint2DatasetsResponse200ApplicationJSONResponseBodyType = Literal["file"]
r"""The type of the content part. Always `file`."""


class UpdateDatapoint2DatasetsFileTypedDict(TypedDict):
    file_data: str
    r"""The base64 encoded file data, used when passing the file to the model as a string."""
    filename: str
    r"""The name of the file, used when passing the file to the model as a string."""


class UpdateDatapoint2DatasetsFile(BaseModel):
    file_data: str
    r"""The base64 encoded file data, used when passing the file to the model as a string."""

    filename: str
    r"""The name of the file, used when passing the file to the model as a string."""


class UpdateDatapoint2Datasets4TypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsResponse200ApplicationJSONResponseBodyType
    r"""The type of the content part. Always `file`."""
    file: UpdateDatapoint2DatasetsFileTypedDict


class UpdateDatapoint2Datasets4(BaseModel):
    type: UpdateDatapoint2DatasetsResponse200ApplicationJSONResponseBodyType
    r"""The type of the content part. Always `file`."""

    file: UpdateDatapoint2DatasetsFile


UpdateDatapoint2DatasetsResponse200ApplicationJSONType = Literal["input_audio"]

UpdateDatapoint2DatasetsFormat = Literal["mp3", "wav"]
r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class UpdateDatapoint2DatasetsInputAudioTypedDict(TypedDict):
    data: str
    r"""Base64 encoded audio data."""
    format_: UpdateDatapoint2DatasetsFormat
    r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class UpdateDatapoint2DatasetsInputAudio(BaseModel):
    data: str
    r"""Base64 encoded audio data."""

    format_: Annotated[UpdateDatapoint2DatasetsFormat, pydantic.Field(alias="format")]
    r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class UpdateDatapoint2Datasets3TypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsResponse200ApplicationJSONType
    input_audio: UpdateDatapoint2DatasetsInputAudioTypedDict


class UpdateDatapoint2Datasets3(BaseModel):
    type: UpdateDatapoint2DatasetsResponse200ApplicationJSONType

    input_audio: UpdateDatapoint2DatasetsInputAudio


UpdateDatapoint2DatasetsResponse200Type = Literal["image_url"]

UpdateDatapoint2DatasetsDetail = Literal["low", "high", "auto"]
r"""Specifies the detail level of the image."""


class UpdateDatapoint2DatasetsImageURLTypedDict(TypedDict):
    url: str
    r"""Either a URL of the image or the base64 encoded image data."""
    detail: NotRequired[UpdateDatapoint2DatasetsDetail]
    r"""Specifies the detail level of the image."""


class UpdateDatapoint2DatasetsImageURL(BaseModel):
    url: str
    r"""Either a URL of the image or the base64 encoded image data."""

    detail: Optional[UpdateDatapoint2DatasetsDetail] = None
    r"""Specifies the detail level of the image."""


class UpdateDatapoint2Datasets2TypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsResponse200Type
    image_url: UpdateDatapoint2DatasetsImageURLTypedDict


class UpdateDatapoint2Datasets2(BaseModel):
    type: UpdateDatapoint2DatasetsResponse200Type

    image_url: UpdateDatapoint2DatasetsImageURL


UpdateDatapoint2DatasetsResponseType = Literal["text"]


class UpdateDatapoint2Datasets1TypedDict(TypedDict):
    type: UpdateDatapoint2DatasetsResponseType
    text: str


class UpdateDatapoint2Datasets1(BaseModel):
    type: UpdateDatapoint2DatasetsResponseType

    text: str


UpdateDatapointContentDatasetsResponse2TypedDict = TypeAliasType(
    "UpdateDatapointContentDatasetsResponse2TypedDict",
    Union[
        UpdateDatapoint2Datasets1TypedDict,
        UpdateDatapoint2Datasets2TypedDict,
        UpdateDatapoint2Datasets3TypedDict,
        UpdateDatapoint2Datasets4TypedDict,
    ],
)


UpdateDatapointContentDatasetsResponse2 = TypeAliasType(
    "UpdateDatapointContentDatasetsResponse2",
    Union[
        UpdateDatapoint2Datasets1,
        UpdateDatapoint2Datasets2,
        UpdateDatapoint2Datasets3,
        UpdateDatapoint2Datasets4,
    ],
)


UpdateDatapointMessagesDatasetsResponseContentTypedDict = TypeAliasType(
    "UpdateDatapointMessagesDatasetsResponseContentTypedDict",
    Union[str, List[UpdateDatapointContentDatasetsResponse2TypedDict]],
)
r"""The contents of the user message."""


UpdateDatapointMessagesDatasetsResponseContent = TypeAliasType(
    "UpdateDatapointMessagesDatasetsResponseContent",
    Union[str, List[UpdateDatapointContentDatasetsResponse2]],
)
r"""The contents of the user message."""


class UpdateDatapointMessagesDatasetsUserMessageTypedDict(TypedDict):
    role: UpdateDatapointMessagesDatasetsResponse200ApplicationJSONRole
    r"""The role of the messages author, in this case `user`."""
    content: UpdateDatapointMessagesDatasetsResponseContentTypedDict
    r"""The contents of the user message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class UpdateDatapointMessagesDatasetsUserMessage(BaseModel):
    role: UpdateDatapointMessagesDatasetsResponse200ApplicationJSONRole
    r"""The role of the messages author, in this case `user`."""

    content: UpdateDatapointMessagesDatasetsResponseContent
    r"""The contents of the user message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


UpdateDatapointMessagesDatasetsResponse200Role = Literal["system"]
r"""The role of the messages author, in this case `system`."""


class UpdateDatapointMessagesDatasetsSystemMessageTypedDict(TypedDict):
    role: UpdateDatapointMessagesDatasetsResponse200Role
    r"""The role of the messages author, in this case `system`."""
    content: str
    r"""The contents of the system message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class UpdateDatapointMessagesDatasetsSystemMessage(BaseModel):
    role: UpdateDatapointMessagesDatasetsResponse200Role
    r"""The role of the messages author, in this case `system`."""

    content: str
    r"""The contents of the system message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


UpdateDatapointMessagesDatasetsResponseRole = Literal["developer"]
r"""The role of the messages author, in this case  `developer`."""


class UpdateDatapointMessagesDatasetsDeveloperMessageTypedDict(TypedDict):
    role: UpdateDatapointMessagesDatasetsResponseRole
    r"""The role of the messages author, in this case  `developer`."""
    content: str
    r"""The contents of the developer message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class UpdateDatapointMessagesDatasetsDeveloperMessage(BaseModel):
    role: UpdateDatapointMessagesDatasetsResponseRole
    r"""The role of the messages author, in this case  `developer`."""

    content: str
    r"""The contents of the developer message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


UpdateDatapointDatasetsMessagesTypedDict = TypeAliasType(
    "UpdateDatapointDatasetsMessagesTypedDict",
    Union[
        UpdateDatapointMessagesDatasetsDeveloperMessageTypedDict,
        UpdateDatapointMessagesDatasetsSystemMessageTypedDict,
        UpdateDatapointMessagesDatasetsUserMessageTypedDict,
        UpdateDatapointMessagesDatasetsToolMessageTypedDict,
        UpdateDatapointMessagesDatasetsAssistantMessageTypedDict,
    ],
)


UpdateDatapointDatasetsMessages = TypeAliasType(
    "UpdateDatapointDatasetsMessages",
    Union[
        UpdateDatapointMessagesDatasetsDeveloperMessage,
        UpdateDatapointMessagesDatasetsSystemMessage,
        UpdateDatapointMessagesDatasetsUserMessage,
        UpdateDatapointMessagesDatasetsToolMessage,
        UpdateDatapointMessagesDatasetsAssistantMessage,
    ],
)


class UpdateDatapointResponseBodyTypedDict(TypedDict):
    r"""Dataset item updated."""

    id: str
    r"""The unique identifier of the dataset item"""
    workspace_id: str
    r"""The unique identifier of the workspace it belongs to"""
    dataset_id: str
    r"""The unique identifier of the dataset"""
    inputs: NotRequired[Dict[str, Any]]
    r"""The inputs of the dataset. Key value pairs where the key is the input name and the value is the input value. Nested objects are not supported."""
    messages: NotRequired[List[UpdateDatapointDatasetsMessagesTypedDict]]
    r"""A list of messages comprising the conversation so far"""
    expected_output: NotRequired[str]
    created_by_id: NotRequired[str]
    r"""The unique identifier of the user who created the dataset"""
    updated_by_id: NotRequired[str]
    r"""The unique identifier of the user who last updated the dataset"""
    created: NotRequired[datetime]
    r"""The date and time the resource was created"""
    updated: NotRequired[datetime]
    r"""The date and time the resource was last updated"""


class UpdateDatapointResponseBody(BaseModel):
    r"""Dataset item updated."""

    id: Annotated[str, pydantic.Field(alias="_id")]
    r"""The unique identifier of the dataset item"""

    workspace_id: str
    r"""The unique identifier of the workspace it belongs to"""

    dataset_id: str
    r"""The unique identifier of the dataset"""

    inputs: Optional[Dict[str, Any]] = None
    r"""The inputs of the dataset. Key value pairs where the key is the input name and the value is the input value. Nested objects are not supported."""

    messages: Optional[List[UpdateDatapointDatasetsMessages]] = None
    r"""A list of messages comprising the conversation so far"""

    expected_output: Optional[str] = None

    created_by_id: Optional[str] = None
    r"""The unique identifier of the user who created the dataset"""

    updated_by_id: Optional[str] = None
    r"""The unique identifier of the user who last updated the dataset"""

    created: Optional[datetime] = None
    r"""The date and time the resource was created"""

    updated: Optional[datetime] = parse_datetime("2025-06-26T05:59:30.032Z")
    r"""The date and time the resource was last updated"""
